﻿

Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        ' ---------------------------------------------------------------- 
        EventsAreEnabled = False
        Load_INI()

        'Dim _stream As IO.Stream = Reflection.Assembly.GetExecutingAssembly().GetManifestResourceStream("cross.cur")
        'PictureBox1.Cursor = New Cursor(_stream)
        Cursor = New Cursor("cross.cur")

        ' --------------------------------------------------------------------------
        '  it is important to "SHOW" the form befor to play any sound
        '  sounds played before will play always at MAX-VOLUME 
        ' --------------------------------------------------------------------------
        Me.Hide()

        EventsAreEnabled = False
        If Form1_WindowStateAtStart = "Maximized" Then
            DEBUG_RunInWindow = False
        Else
            DEBUG_RunInWindow = True
        End If
        SetFullScreen()

        ' --------------------------------------------------------------------------
        Application_Init()
        Form2.SetSlots()

        ' --------------------------------------------------------------------------
        If Form2_VisibleAtStart Then
            Form2.Show(Me)
        End If

        Text = AppTitleAndVersion("")
        EventsAreEnabled = True

        ' PlayObjectSound(1)
        ' --------------------------------------------------------------------------
        Refresh()
        Me.Opacity = 1
    End Sub

    Private Sub ToggleFullScreen()
        DEBUG_RunInWindow = Not DEBUG_RunInWindow
        SetFullScreen()
    End Sub

    Friend Sub SetFullScreen()
        If DEBUG_RunInWindow Then
            Me.WindowState = FormWindowState.Normal
            Me.FormBorderStyle = Windows.Forms.FormBorderStyle.Sizable
            Me.ControlBox = True
            Me.Show()
            Me.Refresh()
        Else
            Me.FormBorderStyle = Windows.Forms.FormBorderStyle.None
            Me.ControlBox = False
            Me.WindowState = FormWindowState.Maximized
            Me.Show()
            Me.Refresh()
        End If
        DX_Resize(Me)
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Return
        DX_Resize(Me)
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        If DEBUG_RunInWindow Then
            LimitFormToAllScreens(Me)
        End If
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) Handles Me.FormClosing
        CloseAll()
    End Sub

    Private Sub CloseAll()
        Application_Closing = True
        Save_INI()
        StopTimers()
        Application_Close()
        End
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ExecFromTimer()
    End Sub

    Private Sub Form1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        If Not EventsAreEnabled Then Return
        DX_MouseDown(e)
        Cursor.Clip = Me.Bounds
    End Sub
    Private Sub Form1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        If Not EventsAreEnabled Then Return
        DX_MouseMove(e)
        ' TODO
        ' -------------------------------------------- posizionamento del cursore 
        'EventsAreEnabled = False
        'Cursor.Position = PictureBox1.PointToScreen(StartCursorPos)
        'EventsAreEnabled = True
    End Sub

    Private Sub Form1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseUp
        If Not EventsAreEnabled Then Return
        DX_MouseUp()
        Cursor.Clip = Nothing
    End Sub

    Private Sub Form1_MouseWheel(ByVal sender As Object, ByVal e As MouseEventArgs) Handles Me.MouseWheel
        If Not EventsAreEnabled Then Return
        'DX_ChangeLens(e.Delta)
        DX_MouseWheel(e.Delta)
    End Sub

    Friend Sub Form1_KeyDown(ByVal sender As Object, ByVal e As KeyEventArgs) Handles Me.KeyDown
        If Not Me.Focused Then Exit Sub
        If Not EventsAreEnabled Then Exit Sub
        EventsAreEnabled = False

        Select Case e.KeyCode
            Case Keys.F1, Keys.H
                If Form2.Visible Then
                    If Form2.WindowState <> FormWindowState.Normal Then
                        Form2.WindowState = FormWindowState.Normal
                    Else
                        Form2.Hide()
                    End If
                Else
                    Form2.Show(Me)
                End If

            Case Keys.Escape
                If Not DEBUG_RunInWindow Then
                    CloseAll()
                    Me.Close()
                End If

            Case Keys.Space : DX_ChangeControlType()
            Case Keys.P : Bullet_Paused = Not Bullet_Paused


            Case Keys.S : DX_ToggleShadows() : Form2.DisplayDebugParams()
            Case Keys.V : DX_ToggleViewFinalMap() : Form2.DisplayDebugParams()
            Case Keys.Q : DX_ToggleQuality() : Form2.DisplayDebugParams()
            Case Keys.W : DEBUG_DrawWireFrame = Not DEBUG_DrawWireFrame : Form2.DisplayDebugParams()
            Case Keys.F : ToggleFullScreen() : Form2.DisplayDebugParams()
            Case Keys.T : DEBUG_UseThreads = Not DEBUG_UseThreads : Form2.DisplayDebugParams()
            Case Keys.M : DEBUG_ShowMovements = Not DEBUG_ShowMovements : Form2.DisplayDebugParams()

            Case Keys.R : App_StartScene()
            Case Keys.D0 : SetCurrentScene(0, e.Control) : App_StartScene()
            Case Keys.D1 : SetCurrentScene(1, e.Control) : App_StartScene()
            Case Keys.D2 : SetCurrentScene(2, e.Control) : App_StartScene()
            Case Keys.D3 : SetCurrentScene(3, e.Control) : App_StartScene()
            Case Keys.D4 : SetCurrentScene(4, e.Control) : App_StartScene()
            Case Keys.D5 : SetCurrentScene(5, e.Control) : App_StartScene()
            Case Keys.D6 : SetCurrentScene(6, e.Control) : App_StartScene()
            Case Keys.D7 : SetCurrentScene(7, e.Control) : App_StartScene()
            Case Keys.D8 : SetCurrentScene(8, e.Control) : App_StartScene()
            Case Keys.D9 : SetCurrentScene(9, e.Control) : App_StartScene()
        End Select
        EventsAreEnabled = True
    End Sub

    Private Sub SetCurrentScene(ByVal n As Int32, ByVal CtrlPressed As Boolean)
        If CtrlPressed Then
            App_CurrentScene = n * 10 + 1
        Else
            App_CurrentScene = (App_CurrentScene \ 10) * 10 + n
        End If
    End Sub

End Class


