


BULLETWRAPPER_API __int32 Bullet_SoftObj_CreatePatch(__int32 resx, _
												     __int32 resy, _
												     float size, _
												     float y)
{
	btSoftBody*	softBody = btSoftBodyHelpers::CreatePatch(mSoftBodyWorldInfo,
														  btVector3(-size,0,-size),
														  btVector3(+size,0,-size),
														  btVector3(-size,0,+size),
														  btVector3(+size,0,+size),
														  resx,
														  resy,
														  4+8,//1+2+4+8,
														  true);

	btSoftBody::Material* pm = softBody->appendMaterial();
	pm->m_flags	-= btSoftBody::fMaterial::DebugDraw;

	// ----------------------------------------------------------------------------- 1
	pm->m_kLST					= 0.4F; // Linear stiffness coefficient
	pm->m_kAST					= 0.1F;	// Area/Angular stiffness coefficient
	pm->m_kVST					= 0.5F;	// Volume stiffness coefficient
	softBody->m_cfg.kDF			= 1.F;  // Area/Angular stiffness coefficient
	softBody->m_cfg.kSRHR_CL	= 1.F;
	softBody->m_cfg.kSR_SPLT_CL	= 0.0F;

	softBody->setTotalMass(100.0F);

	// ----------------------------------------------------------------------------- 3 ( roby 2 )
//	pm->m_kLST						= 0.5F;	// Linear stiffness coefficient
//	pm->m_kAST						= 0.1F;	// Area/Angular stiffness coefficient
//	pm->m_kVST						= 0.5F;	// Volume stiffness coefficient
//
//	softBody->m_cfg.kDP				= 0.001;// Damping coefficient
//	softBody->m_cfg.kDF				= 0.5;	// Dynamic friction coefficient
////   softBody->m_cfg.kMT			= 0.01;	// Pose matching coefficient
////   softBody->m_cfg.kPR			= 2500;
////   softBody->m_cfg.kCHR			= 1;	// Rigid contacts hardness
////   softBody->m_cfg.kKHR			= 0.8;	// Kinetic contacts hardness
////   softBody->m_cfg.kSHR			= 1;	// Soft contacts hardness
//	softBody->m_cfg.piterations		= 2;	// Positions solver iterations
//
//	softBody->setTotalMass(60.0F);
//	softBody->randomizeConstraints();


	// -------------------------------------------------------------------------------------
	//softBody->generateBendingConstraints(0.2f, pm);
	//softBody->getCollisionShape()->setMargin(0.005F);

	// ------------------------------------------------------------------------------------- COLLISIONS
	softBody->m_cfg.collisions = btSoftBody::fCollision::CL_RS;	// rigid body - soft body 
	//softBody->m_cfg.collisions += btSoftBody::fCollision::CL_SS;	// soft body - soft body
	softBody->m_cfg.collisions += btSoftBody::fCollision::CL_SELF;  // self collisions
	//softBody->m_cfg.collisions += btSoftBody::fCollision::VF_SS;	// ??

	// ------------------------------------------------------------------------------------- CLUSTERS
	//softBody->generateClusters(0); // zero = cluster for each tetrahedron or triangle
	softBody->generateClusters(100);

	// ------------------------------------------------------------------------------------- translate and scale
	softBody->translate(btVector3(0,y,0));
	//softBody->scale(btVector3(.5f,.5f,.5f));

	// ------------------------------------------------------------------------------------- 
	mWorld->addSoftBody(softBody);
	// ------------------------------------------------------------------------------------- return
	__int32 ObjIndex = mWorld->getNumCollisionObjects()-1;
	SetUserPointer(ObjIndex);
	return ObjIndex;
}